/**
 * 
 */
package de.bsvrz.ste.rdstmcvew;

import static org.junit.Assert.*;

import java.io.IOException;
import java.io.InputStream;

import de.bsvrz.dav.daf.main.ClientDavConnection;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.ClientDavParameters;
import de.bsvrz.sys.funclib.debug.Debug;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import sun.awt.PlatformFont;

/**
 * Junit-Test fr Testfall 2 der Prfspezifikation.  
 * Ein laufendes Kernsystem wird vorausgesetzt.
 * 
 * @author Dambach Werke GmbH
 * @author Hilpp
 * @version $Revision: 1.3 $ / $Date: 2009/02/13 08:48:40 $ / ($Author: Hilpp $)
 *
 */
public class RdsMeldungTest2 
{
	 /**
   * Datenverteilerverbindung.
   */
  private static ClientDavInterface m_connection = null;
  private static RdsMeldung m;
  
  /**
   * Aufbau der Datenverteilerverbindung.
   * 
   * @throws Exception kann durch verschiedene Quellen erzeut werden.
   */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception
	{
		
		m = new RdsMeldung(); 
		
		m_connection = m.prozessStart(m_connection, "Starte Testfall 2 ");

	}
	
	 /**
   * Abbau der Datenverteilerverbindung.
   * 
   * @throws Exception kann durch verschiedene Quellen erzeut werden.
   */
	@AfterClass
	public static void tearDownAfterClass() throws Exception
	{
		m.prozessStop();
		m_connection.disconnect(false, "");
	}

	/**
	 * Instanz auf die zu prfende Klasse
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception
	{
		m.iniRdsMeldung(m_connection);
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception
	{
	}

	/**
	 * Test method for {@link de.bsvrz.ste.rdstmcvew.RdsMeldung#testfall(de.bsvrz.dav.daf.main.ClientDavInterface, java.lang.String)}.
	 */
	@Test
	public void testTestfall()
	{
		try
		{
			assertTrue("Test 2", m.testfall( m_connection,"Testfall2", 1) );
		} 
		catch (Exception e)
		{
			 assertEquals("Test 2", e.getMessage(), "Ungltige Exeption geworfen");
		}
	}

}
